import peasy.*;
PeasyCam cam;
import controlP5.*;
ControlP5 cp5;
import processing.opengl.*;

PFont f;


Table table,table2, matrix, matrixD;

Movie[] movies;

ArrayList<Movie> comedy = new ArrayList<Movie>();
ArrayList<Movie> action = new ArrayList<Movie>();
ArrayList<Movie> historical = new ArrayList<Movie>();
ArrayList<Movie> romance = new ArrayList<Movie>();
ArrayList<Movie> drama = new ArrayList<Movie>();
ArrayList<Movie> fantasy = new ArrayList<Movie>();
ArrayList<Movie> movie = new ArrayList<Movie>();
boolean showAction=true;
boolean showComedy=false;
boolean showHistorical=false;
boolean showRomance=false;
boolean showDrama=false;
boolean showFantasy=false;
boolean showVertex=false;

ArrayList<Movie> vertex = new ArrayList<Movie>();



Movie selectedWord = null;

//for 2D data analysis
boolean show2D=false;
int marginLeft = 10, marginTop = 70;
float linePos=0;
int cellH = 10;
int numRows;
Cell[] cells;
ArrayList<Cell> cell = new ArrayList<Cell>();

int yearMove;

Range range;
CheckBox checkbox, checkbox2, checkbox3, checkbox4, checkbox5,checkbox6;

int lowAngle=1,hignAngle=360;

String [] month = {"JAN","FEB","MAR","APR","MAY","JUN","JUL","AUG","SEP","OCT","NOV","DEC"};




void setup() {
  fullScreen(P3D);
  cam = new PeasyCam(this, 100);
  cam.setMinimumDistance(200);
  cam.setMaximumDistance(5000);
  loadData(); 
  matrixData();
  println(action.size());
  println(comedy.size());
  println(cells.length);
  f = createFont("Lato-Bold.ttf", 60);
  gui();
  smooth();
}


void draw() {
  background(0);
  //draw measurable information
  stroke(255, 255);
  strokeWeight(0.5);
  noFill();
  int r= 150;
  ellipse(0, 0, r, r);
  stroke(255, 255);
  strokeWeight(2);
  noFill();
  ellipse(0, 0, 1.04*r, 1.04*r);
  float inc = TWO_PI/12.0;
  for(int i=0;i < 12;i++){
    pushMatrix();
    line(0.48*r*cos(i*inc),0.48*r*sin(i*inc),0,0.5*r*cos(i*inc),0.5*r*sin(i*inc),0);
    popMatrix();
    pushMatrix();
    translate(0.5*r*cos(i*inc),0.5*r*sin(i*inc),0);
    rotateZ(i*inc);
    textAlign(LEFT,CENTER);
    textFont(f,3);
    fill(255);
    text(month[i],5,0,0);
    popMatrix();
  }
  
  
  

  
//for moving year
   
   translate(0,0,yearMove);
   drawMovies();
   if(showVertex){
     vertexM();
   }
   
   
   



//for 2D  
   hint(DISABLE_DEPTH_TEST);
   cam.beginHUD();
   cp5.draw();
   
    pushMatrix();
    textAlign(LEFT,CENTER);  
    fill(255);
    textFont(f,15);
    text("POPULARITY OF MOVIE GENRE OF "+"\n"+"SEATLE'S LIBRIARY"+"\n" +"THROUGH YEAR",80,80);
    popMatrix();
    
    pushMatrix();
    textAlign(LEFT,CENTER);  
    fill(255);
    textFont(f,12);
    text("UP   | ZOOM IN",80,height-280);
    text("DOWN | ZOOM OUT",80,height-300);
    text("3    | LINE",80,height-320);
    text("2    | DATE",80,height-340);
    popMatrix();
   
   
   

if(show2D == true){  
  pushMatrix();
  for (int i = 0; i< cells.length; i++) {
    cells[i].drawMatrix();
    cells[i].update();
  }
  lineDraw();
  lineMove();
  popMatrix();
  }
  
   cam.endHUD();
   hint(ENABLE_DEPTH_TEST);
  
  // when interact with cp5, keep camera still. 
  if (cp5.getWindow().isMouseOver()) {
    cam.setActive(false);
  } else {
    cam.setActive(true);
  }
}
